
; ========================================================
;			
;    -- DirectSoundTest.inc --
;			Jay Sullivan
; ========================================================
  
;#################################################
;#                Macro
;#################################################



	$String MACRO sTEXT
		LOCAL szText
		.data
		 szText db sTEXT, 0
		.code
		EXITM <Offset szText>
	ENDM
	
	
	$Const MACRO Num
		result textequ @CatStr(<c_>,<%Num>)
	% IFNDEF result
		  .const 
		    result dd Num
		  .code
	  ENDIF
		EXITM <result>
	ENDM
  
	$fConst MACRO Num
	 	IFIDN @SubStr(<Num>,1,1),<->
	 		dotposition equ @InStr(2,<Num>,<.>)
			formatted textequ @CatStr(<_c_REAL4_>,@SubStr(<Num>,1,dotposition-1),<_>,@SubStr(<Num>,dotposition+1))   
	 		sgnlocation equ @InStr(1,%formatted,<->)
	 		formatted textequ @CatStr(<_>,@SubStr(%formatted,1,sgnlocation-1),@SubStr(%formatted,sgnlocation+1))   
	 	ELSE
	 		dotposition equ @InStr(2,<Num>,<.>)
			formatted textequ @CatStr(<c_REAL4_>,@SubStr(<Num>,1,dotposition-1),<_>,@SubStr(<Num>,dotposition+1))   
	 	ENDIF
		%IFNDEF formatted
		  .const 
		    formatted REAL4 Num
		  .code
	 	ENDIF
		EXITM <formatted>
	ENDM
    ;-----------------------------------------------------------------
    ;  Structs
    ;-----------------------------------------------------------------

;#################################################
;#                Include
;#################################################
	include windows.inc
	include user32.inc
	include kernel32.inc
	include ole32.inc
	include dx9macros.inc
	include dsound9.inc

	include \masm32\com\include\oaidl.inc
	include \masm32\com\include\shlobj.inc
	
	includeLib user32.lib
	includeLib kernel32.lib
	includelib ole32.lib
	includelib dsound.lib
;#################################################
;#                .DATA
;#################################################
	.DATA
	ClassName		db "MyDirectSoundTestClass",0
	szAppName		db "DirectSoundTest",0
	szCButton		db "BUTTON",0
	


	CLSID_IDirectSound   GUID      sCLSID_DirectSound
	CLSID_IDirectSound8  GUID      sCLSID_DirectSound8
	
	IID_IDirectSound        GUID      sIID_IDirectSound
	IID_IDirectSound8       GUID      sIID_IDirectSound8
	IID_IDirectSoundBuffer8 GUID      sIID_IDirectSoundBuffer8
	IID_IDirectSoundNotify GUID      sIID_IDirectSoundNotify
	
	


	MaxSoundSize	equ  4096   ; 4k sound buffer
	wf_wFormatTag 		equ  WAVE_FORMAT_PCM
	wf_nChannels 		equ  1; 2 channels format: <SampleLeft, SampleRight>
	wf_nSamplesPerSec	equ  44100;44100
	wf_wBitsPerSample	equ  16
	wf_nBlockAlign		equ  wf_nChannels * wf_wBitsPerSample / 8
	wf_nAvgBytesPerSec	equ  wf_nSamplesPerSec * wf_nBlockAlign
	wf_cbSize			equ  0
	WaveFormat WAVEFORMATEX <wf_wFormatTag, wf_nChannels, wf_nSamplesPerSec, wf_nAvgBytesPerSec, wf_nBlockAlign, wf_wBitsPerSample, wf_cbSize >
	
	
    myDSBufferDesc DSBUFFERDESC < Sizeof DSBUFFERDESC, \
  								DSBCAPS_CTRLPOSITIONNOTIFY ,\
  								88200 ,\
  								0,\
  								Offset WaveFormat >

	
	myDSPosNotify	DSBPOSITIONNOTIFY <? > 
	
	.DATA?
	hInstance		HINSTANCE ?
	CommandLine		LPSTR ?
	myButton220		HWND ?
	myButton440		HWND ?
	myButton660		HWND ?
	myButton880		HWND ?
	hHeap			dd ?
	hMainWindow		dd ?
	
    pIDirectSound    dd ?
	
